// SpriteDesignerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SpriteDesigner.h"
#include "SpriteDesignerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSpriteDesignerDlg dialog

CSpriteDesignerDlg::CSpriteDesignerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSpriteDesignerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSpriteDesignerDlg)
	m_iWidth = -1;
	m_strCode = _T("");
	m_strSpriteName = _T("");
	m_iHeight = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSpriteDesignerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSpriteDesignerDlg)
	DDX_Control(pDX, IDC_HEIGHTADJ, m_ctlHeight);
	DDX_Radio(pDX, IDC_RADIO1, m_iWidth);
	DDX_Text(pDX, IDC_Code, m_strCode);
	DDX_Text(pDX, IDC_SPRITENAME, m_strSpriteName);
	DDX_Text(pDX, IDC_HEIGHT, m_iHeight);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSpriteDesignerDlg, CDialog)
	//{{AFX_MSG_MAP(CSpriteDesignerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_NEW, OnNew)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_BN_CLICKED(IDC_MakeCode, OnMakeCode)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_EN_CHANGE(IDC_HEIGHT, OnChangeHeight)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSpriteDesignerDlg message handlers

BOOL CSpriteDesignerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Initialize Variables

	m_iWidth=0;
	m_iHeight=0;
	m_bInitialized=FALSE;
	m_ctlHeight.SetRange(16,1);
	m_iHeight=8;
	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSpriteDesignerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSpriteDesignerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
		if (m_bInitialized)
			RedrawGrid();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSpriteDesignerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSpriteDesignerDlg::Drawbox()
{
	m_bInitialized=TRUE;
	UpdateData(TRUE);
	int width=(8*(m_iWidth==0))+(16*(m_iWidth==1))+(32*(m_iWidth==2));
	
	Data.SetSize(width*m_iHeight);

	int x,y,pos;
	for (y=20; y<=180; y+=10)
	{
		for (x=20; x<=340; x+=10)
		{
			if ((x>(width+1)*10)||(y>(m_iHeight+1)*10))
			{
				SetPoint(-1,x,y);
			}
			else
			{
				SetPoint(0,x,y);
				pos=(x-20)/10+(width*((y-20)/10));
				Data[pos]=0;
			}		
		}
	}
}

void CSpriteDesignerDlg::OnNew() 
{
	Drawbox();
	DrawPreview();
}

void CSpriteDesignerDlg::SetPoint(int OnOff, int x, int y)
{
	CClientDC dc(this);
	COLORREF color;
	int width=(8*(m_iWidth==0))+(16*(m_iWidth==1))+(32*(m_iWidth==2));
	int pos=(x-20)/10+(width*((y-20)/10));

	switch(OnOff)
	{
	case 0:
		color=RGB(255,255,255);
		Data[pos]=0;
		break;
	case 1:
		color=RGB(0,0,0);
		Data[pos]=1;
		break;
	case -1:
		color=GetSysColor(COLOR_3DFACE);
		break;
	}		
	
	CBrush brush(color);
	CRect rect(x,y,x+10,y+10);
	dc.FillRect(rect,&brush);
}

void CSpriteDesignerDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	UpdateData(TRUE);
	CClientDC dc(this);
	int x=((point.x/10)*10);
	int y=((point.y/10)*10);
	//int data;
	int width=(8*(m_iWidth==0))+(16*(m_iWidth==1))+(32*(m_iWidth==2));
	int height=(8*(m_iHeight==0))+(16*(m_iHeight==1));
	int pos=(x-20)/10+(width*((y-20)/10));

	//if (m_bInitialized)
	//{
	//	if ((pos<(m_iHeight*width))&&(pos>=0))
	//		data=Data[pos];
	//	else
	//		data=999;
	//	m_strCode.Format("x=%d, y=%d, pos=%d, Data[%d]=%d",x,y,pos,pos,data);
	//	UpdateData(FALSE);
	//}


	
	if ((nFlags & MK_LBUTTON) == MK_LBUTTON)
	{
		if (!(((x>(width+1)*10) || (y>(m_iHeight+1)*10)) || (point.x<20) || (point.y<20)))
		{
			SetPoint(1,x,y);
			DrawPreview();
		}
	}

	if ((nFlags & MK_RBUTTON) == MK_RBUTTON)
	{
		if (!(((x>(width+1)*10) || (y>(m_iHeight+1)*10)) || (point.x<20) || (point.y<20)))
		{
			SetPoint(0,x,y);
			DrawPreview();
		}
	}
	
	CDialog::OnMouseMove(nFlags, point);
}



void CSpriteDesignerDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CClientDC dc(this);
	int x=((point.x/10)*10);
	int y=((point.y/10)*10);
	int width=(8*(m_iWidth==0))+(16*(m_iWidth==1))+(32*(m_iWidth==2));
	int height=(8*(m_iHeight==0))+(16*(m_iHeight==1));

	
	if (!(((x>(width+1)*10) || (y>(m_iHeight+1)*10)) || (point.x<20) || (point.y<20)))
	{
		SetPoint(1,x,y);
		DrawPreview();
	}
	
	CDialog::OnLButtonDown(nFlags, point);
}

void CSpriteDesignerDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CClientDC dc(this);
	int x=((point.x/10)*10);
	int y=((point.y/10)*10);
	int width=(8*(m_iWidth==0))+(16*(m_iWidth==1))+(32*(m_iWidth==2));
	
	if (!(((x>(width+1)*10) || (y>(m_iHeight+1)*10)) || (point.x<20) || (point.y<20)))
	{
		SetPoint(0,x,y);
		DrawPreview();
	}
			
	CDialog::OnRButtonDown(nFlags, point);
}

void CSpriteDesignerDlg::RedrawGrid()
{
	UpdateData(TRUE);
	int width=(8*(m_iWidth==0))+(16*(m_iWidth==1))+(32*(m_iWidth==2));
	int x,y,pos;

	DrawPreview();

	for (y=20; y<180; y+=10)
	{
		for (x=20; x<340; x+=10)
		{
			if ((x>(width+1)*10)||(y>(m_iHeight+1)*10))
			{
				SetPoint(-1,x,y);
			}
			else
			{
				pos=(x-20)/10+(width*((y-20)/10));
				SetPoint(Data[pos],x,y);
			}		
		}
	}
}


void CSpriteDesignerDlg::OnMakeCode()
{
	UpdateData(TRUE);
	if (m_bInitialized==FALSE)
		return;

	if (m_strSpriteName.GetLength()==0)
	{
		MessageBox("You must enter a name for the sprite!");
		return;
	}
	CString temp,temp2,bit1,bit2,bit3,bit4,bit5,bit6,bit7,bit8;
	int width=(8*(m_iWidth==0))+(16*(m_iWidth==1))+(32*(m_iWidth==2));
	int x,y;

	switch(width)
	{
	case 8:
		m_strCode="static unsigned char "+m_strSpriteName+"[] = {";
		break;
	case 16:
		m_strCode="static unsigned short int "+m_strSpriteName+"[] = {";
		break;
	case 32:
		m_strCode="static unsigned long int "+m_strSpriteName+"[] = {";
		break;
	}

	for (x=0; x<=m_iHeight-1; x++)
		{
		temp="";
			for (y=0; y<=(width-8); y+=8)
			{
				bit1.Format("%d",Data[(x*width)+(y+0)]);
				bit2.Format("%d",Data[(x*width)+(y+1)]);
				bit3.Format("%d",Data[(x*width)+(y+2)]);
				bit4.Format("%d",Data[(x*width)+(y+3)]);
				bit5.Format("%d",Data[(x*width)+(y+4)]);
				bit6.Format("%d",Data[(x*width)+(y+5)]);
				bit7.Format("%d",Data[(x*width)+(y+6)]);
				bit8.Format("%d",Data[(x*width)+(y+7)]);
				
				temp2=bit8+bit7+bit6+bit5+bit4+bit3+bit2+bit1;
				temp=temp+BinToHex(temp2);
				//MessageBox(temp2+" "+temp);
			}
			m_strCode=m_strCode+"0x"+temp+",";
		}
	m_strCode=m_strCode.Left(m_strCode.GetLength()-1)+"};";
	UpdateData(FALSE);
}

CString CSpriteDesignerDlg::BinToHex(CString bin)
{
	CString hex;
	CString hexdata="0123456789ABCDEF";

	int bit1, bit2, bit3, bit4, bit5, bit6, bit7, bit8, dec;
	 
	bit1=bin.GetAt(0)==48?0:1;
	bit2=bin.GetAt(1)==48?0:1;
	bit3=bin.GetAt(2)==48?0:1;
	bit4=bin.GetAt(3)==48?0:1;
	bit5=bin.GetAt(4)==48?0:1;
	bit6=bin.GetAt(5)==48?0:1;
	bit7=bin.GetAt(6)==48?0:1;
	bit8=bin.GetAt(7)==48?0:1;

	dec=(bit5)+(bit6*2)+(bit7*4)+(bit8*8);
	hex=hexdata.GetAt(dec);

	dec=(bit1)+(bit2*2)+(bit3*4)+(bit4*8);
	hex=hex+hexdata.GetAt(dec);
	return hex;
}

void CSpriteDesignerDlg::DrawPreview()
{
	if (m_bInitialized==FALSE)
		return;
	
	CClientDC dc(this);
	int x,y,pos,color,xoffset,yoffset;
	int width=(8*(m_iWidth==0))+(16*(m_iWidth==1))+(32*(m_iWidth==2));
	CRect rect;
	CBrush brush;
	
	xoffset=280;
	yoffset=210;
	
	for (x=0; x<64; x+=2)
	{
		for (y=0; y<32; y+=2)
		{
			if ((x>=(width*2))||(y>=(m_iHeight*2)))
			{
				color=GetSysColor(COLOR_3DFACE);
			}
			else
			{
				pos=(x/2)+(width)*(y/2);
				switch(Data[pos])
				{
				case 0:
					color=RGB(255,255,255);
					break;
				case 1:
					color=RGB(0,0,0);
					break;		
				}	
			}
			
			CBrush brush(color);
				
			rect.SetRect(x+xoffset,y+yoffset,x+xoffset+2,y+yoffset+2);
			dc.FillRect(rect,&brush);
		}
	}
}

void CSpriteDesignerDlg::OnRadio1() 
{
	if (m_iWidth!=0)
		Drawbox();
}

void CSpriteDesignerDlg::OnRadio2() 
{
	if (m_iWidth!=1)
		Drawbox();
}

void CSpriteDesignerDlg::OnRadio3() 
{
	if (m_iWidth!=2)
		Drawbox();
}

void CSpriteDesignerDlg::OnChangeHeight() 
{
	if (m_bInitialized==TRUE)
		Drawbox();	
}
